namespace InABox.Mobile
{
    public class DoubleCombiner : AbstractCombiner<double, NumericCombinerFunction>
    {
        protected override double Combine(double current, double next)
        {
            return Function switch
            {
                NumericCombinerFunction.Sum => current + next,
                NumericCombinerFunction.Product => current * next,
                NumericCombinerFunction.Subtraction => current - next,
                NumericCombinerFunction.Maximum => current > next ? current : next,
                NumericCombinerFunction.Minimum => current < next ? current : next,
                _ => current
            };
        }
    }
}