using System.Linq;

namespace InABox.Mobile
{
    public class IntegerCombiner : AbstractCombiner<int, NumericCombinerFunction>
    {
        protected override int Combine(int current, int next)
        {
            return Function switch
            {
                NumericCombinerFunction.Sum => current + next,
                NumericCombinerFunction.Product => current * next,
                NumericCombinerFunction.Subtraction => current - next,
                NumericCombinerFunction.Maximum => current > next ? current : next,
                NumericCombinerFunction.Minimum => current < next ? current : next,
                _ => current
            };
        }
    }
}